'$DYNAMIC
DECLARE SUB anykey ()
DECLARE SUB title ()
CONST titlemsg = "BBC MICRO SERIAL TRANSFER UTILITY"
CONST anykeymsg = "Press any key to continue"
REM Serial transfer facility
REM ------------------------
REM receives bytes from the BBC Micro and saves them to a file
REM
REM

'
'should be sufficient for about 100K+
DIM storage(2000) AS STRING
DIM ch AS INTEGER, comport AS INTEGER, baudrates(3) AS STRING * 4
DIM tmp AS STRING * 1
'
baudrates(1) = "1200"
baudrates(2) = "2400"
baudrates(3) = "4800"
'
CALL title
PRINT
PRINT "This program enables the transfer of software from a BBC Micro to a PC."
PRINT
PRINT "Please select the COM port the lead is connected to:"
PRINT ":";
DO
        DO
                tmp = INKEY$
        LOOP UNTIL tmp <> ""
        comport = ASC(tmp) - ASC("0")
LOOP UNTIL comport >= 1 AND comport <= 4
PRINT "COM"; comport
' baud rate selection isn't yet implemented on the BBC end... so it's stuck
' at 4800 for the moment!
rate = 3
GOTO SkipBaudRateSelect
PRINT
PRINT "Please select the baud rate for transmission:"
PRINT "1: 1,200 baud"
PRINT "2: 2,400 baud"
PRINT "3: 4,800 baud"
PRINT ":";
DO
        DO
                tmp = INKEY$
        LOOP UNTIL tmp <> ""
        rate = ASC(tmp) - ASC("0")
LOOP UNTIL rate >= 1 AND rate <= 3
PRINT baudrates(rate); " baud"
SkipBaudRateSelect:
CALL anykey
CALL title
PRINT
PRINT "Now run the XFER program on the BBC and follow the instructions there."
CALL anykey
REM **
REM ** the actual routine to receive the file
REM **
CALL title
'flag indicating whether transmission has finished or not
DIM done AS INTEGER
'flag indicating whether (false) header information is being transmitted, or
'(true) actual data.
DIM started AS INTEGER
'flag indicating whether 'Receiving file' message has been printed or not.
'Checking this flag is quicker than printing a message with every byte.
DIM informed AS INTEGER
'flag indicating whether the line width has been calculated.
DIM calculated AS INTEGER

done = 0
started = 0
informed = 0
calculated = 0
PRINT
'
DIM msgy AS INTEGER, progy AS INTEGER, by AS STRING * 1, cly AS INTEGER
DIM currentline AS INTEGER, j AS INTEGER
'
msgy = CSRLIN
PRINT "Awaiting transmission of file from BBC end..."
PRINT "Filename          :"
PRINT "Load address      :"
PRINT "Execution address :"
PRINT "Length            :"
PRINT "Transferred       :"
PRINT "Line width        :"
PRINT "Time taken        :"
PRINT "Progress:"
progy = CSRLIN
PRINT "["; STRING$(78, "."); "]"
PRINT "Current line:"
cly = CSRLIN
currentline = 0
'
DIM comline AS STRING
DIM length AS LONG, execaddr AS LONG, loadaddr AS LONG
DIM bbcname AS STRING
DIM sofar AS LONG
DIM percent AS INTEGER, linewidth AS INTEGER
'
ch = FREEFILE
OPEN "COM2:" + baudrates(rate) + ",N,8,1,BIN" FOR RANDOM AS #ch
WHILE NOT done
        comline = ""
        DO
                GET #ch, , tmp
                IF ASC(tmp) <> 13 AND ASC(tmp) <> 10 THEN
                        comline = comline + tmp
                END IF
        LOOP UNTIL ASC(tmp) = 13
        comline = RTRIM$(UCASE$(LTRIM$(comline$)))
        LOCATE cly, 1
        PRINT comline
        IF NOT started THEN
                IF NOT informed THEN
                        LOCATE msgy%, 1
                        PRINT SPACE$(80);
                        LOCATE msgy%, 1
                        PRINT "Receiving file from BBC..."
                END IF
                IF LEFT$(comline, 5) = "LENG:" THEN
                        length = VAL("&h" + MID$(comline, 6))
                        LOCATE msgy + 4, 20
                        PRINT length
                ELSEIF LEFT$(comline, 5) = "LOAD:" THEN
                        loadaddr = VAL("&H" + MID$(comline, 6))
                        LOCATE msgy + 2, 21
                        PRINT HEX$(loadaddr)
                ELSEIF LEFT$(comline, 5) = "EXEC:" THEN
                        execaddr = VAL("&H" + MID$(comline, 6))
                        LOCATE msgy + 3, 21
                        PRINT HEX$(execaddr)
                ELSEIF LEFT$(comline, 5) = "NAME:" THEN
                        bbcname = MID$(comline, 6)
                        LOCATE msgy + 1, 21
                        PRINT bbcname
                ELSEIF comline = "STARTING NOW..." THEN
                        started = -1
                END IF
        ELSE
                IF comline = "...DONE..." THEN
                        done = -1
                ELSE
                        storage(currentline) = comline
                        currentline = currentline + 1
                        IF NOT calculated THEN
                                IF currentline > 1 THEN
                                        linewidth = VAL("&H" + LEFT$(storage(1), 5)) - VAL("&H" + LEFT$(storage(0), 5))
                                        LOCATE msgy + 6, 20
                                        PRINT linewidth
                                        calculated = -1
                                END IF
                        END IF
                        IF calculated THEN
                                sofar = VAL("&H" + LEFT$(comline, 5)) + ((LEN(comline) - 7) \ 2)
                                LOCATE msgy + 5, 20
                                PRINT sofar
                                percent = (CSNG(sofar) / length) * 78
                                LOCATE progy, 2
                                PRINT STRING$(percent, "*")
                        END IF
                END IF
        END IF
WEND
CLOSE #ch
REM **
REM ** File transfer complete... now save to disk!
REM **
'
DIM outputname AS STRING, outp AS STRING
DIM fh AS INTEGER, t AS INTEGER, t2 AS INTEGER
'
CALL title
PRINT
PRINT "Now saving file to disk..."
outputname = ""
FOR j = 1 TO LEN(bbcname)
        tmp = UCASE$(MID$(bbcname, j, 1))
        IF (tmp >= "0" AND tmp <= "9") OR (tmp >= "A" AND tmp <= "Z") THEN
                outputname = outputname + tmp
        END IF
NEXT j
fh = FREEFILE
OPEN outputname FOR OUTPUT AS #fh
PRINT "Writing header..."
PRINT #fh, "bbcname:" + bbcname + ";"
PRINT #fh, "load:" + HEX$(loadaddr) + ";"
PRINT #fh, "execution:" + HEX$(execaddr) + ";"
PRINT #fh, "length:" + HEX$(length) + ";"
PRINT #fh, "contents:"
PRINT "Writing data..."
progy = CSRLIN
PRINT "["; STRING$(78, "."); "]"
DIM chksum AS LONG
chksum = 0
sofar = 0
FOR t = 0 TO currentline - 1
        outp = MID$(storage(t), 7)
        PRINT #fh, outp
        sofar = sofar + (LEN(outp) \ 2)
        percent = (sofar / CSNG(length)) * 78
        LOCATE progy, 2
        PRINT STRING$(percent, "*")
        FOR t2 = 0 TO LEN(outp) \ 2
                chksum = chksum + VAL("&H" + MID$(outp, 1 + t2 * 2, 2))
        NEXT t2
NEXT t
PRINT #fh, ";"
CLOSE #fh
PRINT "Transfer complete."
PRINT "Checksum: "; chksum
END

REM $STATIC
SUB anykey
        LOCATE 25, 40 - LEN(anykeymsg) \ 2
        PRINT anykeymsg;
        DO
        LOOP UNTIL INKEY$ <> ""
END SUB

SUB title
        CLS
        LOCATE 1, 40 - LEN(titlemsg) \ 2
        PRINT titlemsg
END SUB

